---
title: ImageData()
slug: Web/API/ImageData/ImageData
tags:
  - API
  - Canvas
  - Constructor
  - ImageData
  - Reference
---
<div>{{APIRef("Canvas API")}}</div>

<p>The <code><strong>ImageData()</strong></code> constructor returns a newly instantiated {{domxref('ImageData')}} object built from the typed array given and having the specified width and height.</p>

<p>This constructor is the preferred way of creating such an object in a {{domxref('Worker')}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">new ImageData(<em>array</em>, <em>width</em> [, <em>height</em>]);
new ImageData(<em>width</em>, <em>height</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>array</code> {{optional_inline}}</dt>
 <dd>A {{jsxref("Uint8ClampedArray")}} containing the underlying pixel representation of the image. If no such array is given, an image with a transparent black rectangle of the specified <code>width</code> and <code>height</code> will be created.</dd>
 <dt><code>width</code></dt>
 <dd>An unsigned long representing the width of the image.</dd>
 <dt><code>height</code></dt>
 <dd>An unsigned long representing the height of the image. This value is optional if an array is given: the height will be inferred from the array's size and the given width.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A new {{domxref('ImageData')}} object.</p>

<h3 id="Errors_thrown">Errors thrown</h3>

<dl>
 <dt><code>IndexSizeError</code></dt>
 <dd>Thrown if <code>array</code> is specified, but its length is not a multiple of <code>(4 * width)</code> or <code>(4 * width * height)</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_blank_ImageData_object">Creating a blank ImageData object</h3>

<p>This example creates an <code>ImageData</code> object that is 200 pixels wide and 100 pixels tall, containing a total of 20,000 pixels.</p>

<pre class="brush: js  language-js notranslate">let imageData = new ImageData(200, 100);
// ImageData { width: 200, height: 100, data: Uint8ClampedArray[80000] }
</pre>

<h3 id="Initializing_ImageData_with_an_array">Initializing ImageData with an array</h3>

<p>This example instantiates an <code>ImageData</code> object with pixel colors defined by an array.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>The array (<code>arr</code>) has a length of <code>40000</code>: it consists of 10,000 pixels, each of which is defined by 4 values. The <code>ImageData</code> constructor specifies a <code>width</code> of <code>200</code> for the new object, so its <code>height</code> defaults to 10,000 divided by 200, which is <code>50</code>.</p>

<pre class="brush: js notranslate">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
const arr = new Uint8ClampedArray(40000);

// Iterate through every pixel
for (let i = 0; i &lt; arr.length; i += 4) {
  arr[i + 0] = 0;    // R value
  arr[i + 1] = 190;  // G value
  arr[i + 2] = 0;    // B value
  arr[i + 3] = 255;  // A value
}

// Initialize a new ImageData object
let imageData = new ImageData(arr, 200);

// Draw image data to the canvas
ctx.putImageData(imageData, 20, 20);</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Initializing_ImageData_with_an_array', 700, 180)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'scripting.html#dom-imagedata', 'ImageData()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ImageData.ImageData")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasRenderingContext2D.createImageData()")}}, the creator method that can be used outside workers.</li>
</ul>
